% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 8 MATLAB codes %%%
%%% Figure 8.1 A finite-time wavelet%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
f=10;
dt=0.002;
w = ricker(f,dt);
t=[-length(w)/2:length(w)/2-1]*dt;
plot(t,w,'k','LineWidth',3)
grid
xlabel('{\itt}(s)','FontName','Times','FontSize',14)
ylabel('{\itw} [{\itt}]','FontName','Times','FontSize',14)
axis([min(t),max(t),-0.5,1.1])
set(gcf,'PaperPositionMode','auto')

W=abs(fftshift(fft(w,512)));
F=linspace(-0.5,0.5,512)/dt;
figure, plot(F,W/max(W),'k','LineWidth',3)
grid
xlabel('{\itf}(Hz)','FontName','Times','FontSize',14)
ylabel('Amplitude','FontName','Times','FontSize',14)
axis([0,100,0,1.05])
