% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 8 MATLAB codes %%%
%%% Figure 8.2 Example 8.1%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

n=0:10;
w1=zeros(size(n));
w2=w1;

w1(n==0)=1/2;
w1(n==1)=1;
figure,stem(n,w1,'fill','k','LineWidth',2);
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\itw}_1[{\itn}]','FontName','Times','FontSize',14)
axis([-1,max(n),-1,max(w1)+0.5])
set(gcf,'PaperPositionMode','auto')

w2(n==0)=1;
w2(n==1)=1/2;
figure,stem(n,w2,'fill','k','LineWidth',2);
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\itw}_2[{\itn}]','FontName','Times','FontSize',14)
axis([-1,max(n),-1,max(w1)+0.5])
set(gcf,'PaperPositionMode','auto')


f=linspace(-0.5,0.5,128)*2*pi;
W1=fftshift(fft(w1,128));
W2=fftshift(fft(w2,128));
figure,plot(f,abs(W1),'k',f,abs(W2),'k-.','LineWidth',2);
xlabel('{\it \omega}(rad/s)','FontName','Times','FontSize',14)
hleg=legend('|{\it W}_a{\it (e^{j\omega})}|, maximum-delay','|{\it W}_b{\it (e^{j\omega})}|, minimum-delay');
set(hleg,'FontName','Times')
axis([min(f),max(f),0,2])
grid

figure,plot(f,unwrap(angle(W1))*180/pi,'k',f,unwrap(angle(W2))*180/pi,'k-.','LineWidth',2);
xlabel('{\it \omega}(rad/s)','FontName','Times','FontSize',14)
ylabel('\angle(^o)','FontName','Times','FontSize',14)
hleg=legend('\angle{{\it W}_a{\it (e^{j\omega})}}, maximum-delay','\angle{{\it W}_b{\it (e^{j\omega})}}, minimum-delay');
set(hleg,'FontName','Times')
axis([0,max(f),-13,2.5])
grid
axis tight

