% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 8 MATLAB codes %%%
%%% Figure 8.3 Example 8.3%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

n=0:10;
w1=zeros(size(n));
w2=w1;
w3=w1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%a
w1(n==0)=3;
w1(n==1)=7/2;
w1(n==2)=1;
figure,stem(n,w1,'fill','k','LineWidth',2);
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\itw}_1[{\itn}]','FontName','Times','FontSize',14)
axis([-1,max(n),-1,max(w1)+0.5])
set(gcf,'PaperPositionMode','auto')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%b
w2(n==0)=2;
w2(n==1)=4;
w2(n==2)=3/2;
figure,stem(n,w2,'fill','k','LineWidth',2);
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\itw}_2[{\itn}]','FontName','Times','FontSize',14)
axis([-1,max(n),-1,max(w1)+0.5])
set(gcf,'PaperPositionMode','auto')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%c
w3(n==0)=1;
w3(n==1)=7/2;
w3(n==2)=3;
figure,stem(n,w3,'fill','k','LineWidth',2);
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\itw}_3[{\itn}]','FontName','Times','FontSize',14)
axis([-1,max(n),-1,max(w1)+0.5])
set(gcf,'PaperPositionMode','auto')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%d
%Cumulative energy
Ek1=zeros(1,3);
Ec=0;
l=1;
for i=1:3
    Ek1(i)=Ek1(i)+abs(w1(i))^2;
    Ec=Ek1(i)+Ec;
    Ec_fn1(i)=Ec;
end

Ek1=zeros(1,3);
Ec=0;
l=1;
for i=1:3
    Ek1(i)=Ek1(i)+abs(w2(i))^2;
    Ec=Ek1(i)+Ec;
    Ec_fn2(i)=Ec;
end

Ek1=zeros(1,3);
Ec=0;
l=1;
for i=1:3
    Ek1(i)=Ek1(i)+abs(w3(i))^2;
    Ec=Ek1(i)+Ec;
    Ec_fn3(i)=Ec;
end
figure,stairs([1:3],Ec_fn1,'k','LineWidth',2);
hold on,stairs([1:3],Ec_fn2,'k-.','LineWidth',2);
stairs([1:3],Ec_fn3,'k--','LineWidth',2);
hold off
xlabel('\itn','FontName','Times','FontSize',14)
ylabel('{\itE}_c[{\itn}]','FontName','Times','FontSize',14)
hh=legend('{\itw}_1[{\itn}], minimum-delay','{\itw}_2[{\itn}], mixed-delay','{\itw}_3[{\itn}], maximum-delay');
set(hh,'FontName','Times')
axis([1,3.1,0,max(Ec_fn1)+0.5])
set(gca,'XTick',[1,2,3]);
grid 
set(gcf,'PaperPositionMode','auto');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%e
f=linspace(-0.5,0.5,128)*2*pi;
W1=fftshift(fft(w1,128));
W2=fftshift(fft(w2,128));
W3=fftshift(fft(w3,128));
figure,plot(f,abs(W1),'k',f,abs(W2),'k-.',f,abs(W3),'k--','LineWidth',2);
xlabel('{\it \omega}(rad/s)','FontName','Times','FontSize',14)
hleg=legend('|{\it W}_1{\it (e^{j\omega})}|, minimum-delay','|{\it W}_2{\it (e^{j\omega})}|, mixed-delay','|{\it W}_3{\it (e^{j\omega})}|, maximum-delay');
set(hleg,'FontName','Times');
axis([0,max(f),0,9])
set(gcf,'PaperPositionMode','auto')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%f
figure,plot(f,unwrap(angle(W1))*180/pi,'k',f,unwrap(angle(W2))*180/pi,'k-.',f,unwrap(angle(W3))*180/pi,'k--','LineWidth',2);
xlabel('{\it \omega}(rad/s)','FontName','Times','FontSize',14)
ylabel('\angle(^o)','FontName','Times','FontSize',14)
hleg=legend('\angle{{\it W}_1{\it (e^{j\omega})}}, minimum-delay','\angle{{\it W}_2{\it (e^{j\omega})}}, mixed-delay',...
    '\angle{{\it W}_3{\it (e^{j\omega})}}, maximum-delay');
set(hleg,'FontName','Times');
axis([0,max(f),-13,2.5])
grid
axis tight
set(gcf,'PaperPositionMode','auto');

