% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 8 MATLAB codes %%%
%%% Figure 8.4 Example of a rectangular and a sinc wavelets%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


f=10;
dt=0.004;
tlength=256;
%% The rectangular wavelet
%%a
t=linspace(-3,3,tlength);
w=zeros(size(t));
w((t>=-1)&(t<=1))=1;
figure,plot(t,w,'k','LineWidth',3)
grid
xlabel('{\itt}(s)','FontName','Times','FontSize',14)
ylabel('{\itw}_{\itrect} [{\itt}]','FontName','Times','FontSize',14)
axis([-3,3,-0.1,1.1])
set(gcf,'PaperPositionMode','auto')
%%c
f=linspace(-0.5,0.5,512)*2*pi;
W=fftshift(fft(w,512));
figure,plot(f,abs(W),'k','LineWidth',2);
xlabel('{\it \omega} (rad/s)','FontName','Times','FontSize',14)
ylabel('|{\it W}_{\itrect}{\it (e^{j\omega})}|','FontName','Times','FontSize',14)
axis([min(f),max(f),0,max(abs(W))])
grid
set(gcf,'PaperPositionMode','auto')
%%e
figure,plot(f,unwrap(angle(W))*180/pi,'k','LineWidth',2);
xlabel('{\it \omega} (rad/s)','FontName','Times','FontSize',14)
ylabel('\angle{{\it W}_{\itrect}{\it (e^{j\omega})}}','FontName','Times','FontSize',14)
%axis([0,max(f),-13,2.5])
grid
axis tight
set(gcf,'PaperPositionMode','auto')


%% The sinc wavelet
%%b
f=10;
dt=0.004;
tlength=256;
w=sinc(f*t);
figure,plot(t,w,'k','LineWidth',3)
grid
xlabel('{\itt}(s)','FontName','Times','FontSize',14)
ylabel('{\itw}_{\itsinc} [{\itt}]','FontName','Times','FontSize',14)
%axis([-15,15,-0.1,1.1])
set(gcf,'PaperPositionMode','auto')
%%d
f=linspace(-0.5,0.5,512)*2*pi;
W=fftshift(fft(w,512));
figure,plot(f,abs(W),'k','LineWidth',2);
xlabel('{\it \omega} (rad/s)','FontName','Times','FontSize',14)
ylabel('|{\it W}_{\itsinc}{\it (e^{j\omega})}|','FontName','Times','FontSize',14)
axis([min(f),max(f),0,max(abs(W))])
grid
set(gcf,'PaperPositionMode','auto')
%%f
figure,plot(f,unwrap(angle(W))*180/pi,'k','LineWidth',2);
xlabel('{\it \omega} (rad/s)','FontName','Times','FontSize',14)
ylabel('\angle{{\it W}_{\itsinc}{\it (e^{j\omega})}}','FontName','Times','FontSize',14)
axis([0,max(f),-13,2.5])
grid
axis tight
set(gcf,'PaperPositionMode','auto')






