% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 8 MATLAB codes %%%
%%% Figure 8.5 Example of Ricker wavelets of various frequencies%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tlength=256;
f=10;
dt=0.004;
[w,t]=ricker_m(dt,f,tlength);
[w1,t]=ricker_m(dt,2*f,tlength);
[w2,t]=ricker_m(dt,3*f,tlength);
figure,plot(t,w,'k-',t,w1,'k-.',t,w2,'k--','LineWidth',2)
hold on
plot(t,w1,'k-.','LineWidth',2)
plot(t,w2,'k--','LineWidth',3)
hold off
grid
xlabel('{\itt}(s)','FontName','Times','FontSize',14)
ylabel('{\itw}_{\itRicker} [{\itt}]','FontName','Times','FontSize',14)
axis([-0.15,0.15,-0.5,1.1])
hleg=legend('{\itf}=10Hz','{\itf}=20Hz','{\itf}=30Hz');
set(hleg,'FontName','Times')
set(gcf,'PaperPositionMode','auto')


