% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 8 MATLAB codes %%%
%%% Figure 8.6 Example of shifted Ricker wavelets%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
t= -pi/4:.001:pi/4;
fmax=20;
%%
phase = 0 ;
Amplitude = cos(2 .* pi .* 1 * t + phase);
for freq=2:fmax
    Amplitude = (Amplitude + cos (t .* 2 .* pi .* freq + phase));
end
nx=16;
Seis1=repmat(Amplitude'/fmax,1,nx);
figure,mwigb(Seis1,1,[1:nx],[0:1571-1]*0.001)
xlabel('Trace number','FontName','Times','FontSize',14)
ylabel('Time(s)','FontName','Times','FontSize',14)
set(gcf,'PaperPositionMode','auto')
%%
phase = 1 * pi/4 ;
Amplitude = cos(2 .* pi .* 1 * t + phase);
for freq=2:fmax
    Amplitude = (Amplitude + cos(t .* 2 .* pi .* freq + phase));
end
nx=16;
Seis1=repmat(Amplitude'/fmax,1,nx);
figure,mwigb(Seis1,1,[1:nx],[0:1571-1]*0.001)
xlabel('Trace number','FontName','Times','FontSize',14)
ylabel('Time(s)','FontName','Times','FontSize',14)
set(gcf,'PaperPositionMode','auto')
%%
phase = pi/2;
clear Amplitude
Amplitude = cos(2 .* pi .* 1 * t + phase);
for freq=2:fmax
    Amplitude = (Amplitude + cos (t .* 2 .* pi .* freq + phase));
end
nx=16;
Amplitude=-1*Amplitude;
Seis1=repmat(Amplitude'/fmax,1,nx);
figure,mwigb(Seis1,1,[1:nx],[0:1571-1]*0.001)
xlabel('Trace number','FontName','Times','FontSize',14)
ylabel('Time(s)','FontName','Times','FontSize',14)
set(gcf,'PaperPositionMode','auto')